// ReadWriteLockSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ReadWriteLockSample.h"
#include "ReadWriteLockSampleDlg.h"
#include "ReaderThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReadWriteLockSampleDlg dialog

CReadWriteLockSampleDlg::CReadWriteLockSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReadWriteLockSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CReadWriteLockSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReadWriteLockSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReadWriteLockSampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReadWriteLockSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CReadWriteLockSampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(UDC_NEW_READER, OnNewReader)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadWriteLockSampleDlg message handlers

BOOL CReadWriteLockSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
    SetTimer( 1, 1000, NULL );
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReadWriteLockSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReadWriteLockSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReadWriteLockSampleDlg::OnNewReader() 
{
    AfxBeginThread( RUNTIME_CLASS( CReaderThread ) );	
}

void CReadWriteLockSampleDlg::OnTimer(UINT nIDEvent) 
{
    if (nIDEvent == 1)
    {
        COleDateTime Time = COleDateTime::GetCurrentTime();
        CString S = Time.Format(VAR_TIMEVALUEONLY);
        theApp.m_String.SetString(S);
    }

	CDialog::OnTimer(nIDEvent);
}
