// ReadWriteLockTestDlg.h : header file
//

#if !defined(AFX_READWRITELOCKTESTDLG_H__1141D944_4C29_4C95_9A83_21DF025A381F__INCLUDED_)
#define AFX_READWRITELOCKTESTDLG_H__1141D944_4C29_4C95_9A83_21DF025A381F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CReadWriteLockTestDlg dialog

class CReadWriteLockTestDlg : public CDialog
{
// Construction
public:
	CReadWriteLockTestDlg(BOOL bMainThread, CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CReadWriteLockTestDlg)
	enum { IDD = IDD_READWRITELOCKTEST_DIALOG };
	CString	m_ThreadType;
	CString	m_State;
	int		m_Timeout;
	CString	m_ReadLocksStr;
	CString	m_WriteLocksStr;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CReadWriteLockTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
    BOOL  m_bMainThread;
    int   m_ReadLocks;
    int   m_WriteLocks;

	// Generated message map functions
	//{{AFX_MSG(CReadWriteLockTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnReadLock();
	afx_msg void OnWriteLock();
	afx_msg void OnReadUnlock();
	afx_msg void OnWriteUnlock();
	afx_msg void OnNewThread();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_READWRITELOCKTESTDLG_H__1141D944_4C29_4C95_9A83_21DF025A381F__INCLUDED_)
