#ifndef SHAREDSTRING_H_INCLUDED
#define SHAREDSTRING_H_INCLUDED

#pragma once

#ifndef READWRITELOCK_H_INCLUDED
#include "ReadWriteLock.h"
#endif //READWRITELOCK_H_INCLUDED

class KSharedString
{
public:
    CString GetString()
        {
            KReadLock Lock(m_Lock);
            return m_String;
        };

    void SetString( CString const& S )
        {
            KWriteLock Lock(m_Lock);
            m_String = S;
        };

private:
    KReadWriteLock m_Lock;
    CString m_String;
};

#endif //SHAREDSTRING_H_INCLUDED
